function H = fft1(h)
% FFT1 Calculates a 1-sided fft with the same scaling as the standard fft
% 
% DESCRIPTION:
% Single-sided fft transform, f = 0 ... fs/2
% number of input samples must be even
% size(h) = 2N  -->  size(H) = N+1   f = (0:N)/(2*N)*fs
% 
% HISTORY:  
% Version 0.1 1999-08-18 Created by Pal Frenger KI/ERA/T/UR
% 
% Copyright (c) 1999 by Ericsson Radio AB

N = max(size(h));
if (2*fix(N/2)) ~= N
  fprintf('Input to FFT1-routine does not have an even number of points');
  return;
end

H1 = fft(h);
H  = H1(1:(N/2+1));
