function EVMrms = ak_evm(referenceSignal, otherSignal)
% function EVMrms = ak_evm(referenceSignal, otherSignal)
%Calculate RMS Error Vector Magnitude (EVM) in %. The output is
%the mean square value of the error = referenceSignal - otherSignal
%normalized by the mean square value of referenceSignal times 100.
error = referenceSignal - otherSignal;
mse = mean(abs(error).^2);
EVMrms = sqrt(mse/mean(abs(referenceSignal).^2))*100;
%See,e.g., http://www.mathworks.com/help/comm/ref/evmmeasurement.html