function noise = calc_noise(P,H,victimIdx)
% function noise = calc_noise(P,H,victimIdx)
% Generate background noise plus crosstalk

%Assume -140 dBm/Hz as background noise
%1e-17 Watts = 10*log10(1e-17/1e-3) = -140 dBm
bg_noise = 1e-17;

%get dimensions
[ n_users n_tones ] = size(P);

%Adding background noise
noise = bg_noise * ones(1,n_tones);

for i=1:n_users,
	if i == victimIdx,
        %skip the victim modem. it does not have xtak to itself
		continue;
    end
	noise = noise + P(i,:) .* H{victimIdx,i};
end

%endfunction