%Script rule3db.m
%show the 3 dB rule of thumb
gapdb = [0 6 12];
snrdb = [-10:50];
c = zeros(length(gapdb),length(snrdb));
close all
hold on
for i=1:length(gapdb)
    gap = 10.^(gapdb(i)/10);
    snr = 10.^(snrdb/10);
    c(i,:) = log2(1 + snr/gap);
end
plot(snrdb,c');
xlabel('SNR/gap (dB)');
ylabel('Bits per complex dimension')
grid
legend('\Gamma_{dB}=0','\Gamma_{dB}=6','\Gamma_{dB}=12')

print -depsc 'bitspersnr.eps'

%another way of looking at it
figure(2)
bits=1:15;
snrgap = 10*log10(2.^bits-1);
plot(bits,snrgap);
ylabel('SNR/gap (dB)');
xlabel('Bits per complex dimension')
grid
print -depsc 'snrperbits.eps'