function ak_makedatatip(hTarget,position)
% function ak_makedatatip(hTarget,position)
% Example 1:
%     xdata=1:10;
%     ydata=1:10;
%     h = plot(xdata,ydata);
%     position=[2 2];
%     ak_makedatatip(h,position)
% Example 2:
%     h=imagesc(magic(6));
%     position=[3 4];
%     ak_makedatatip(h,position)

% First get the figure's data-cursor mode, activate it, and set some of its properties
cursorMode = datacursormode(gcf);
    %'UpdateFcn',@setDataTipTxt, 
set(cursorMode, 'enable','on',...
    'NewDataCursorOnClick',false);
% Note: the optional @setDataTipTxt is used to customize the data-tip's appearance
 
% Note: the following code was adapted from %matlabroot%\toolbox\matlab\graphics\datacursormode.m
% Create a new data tip
%hTarget = handle(hLine);
hDatatip = cursorMode.createDatatip(hTarget);
 
% Create a copy of the context menu for the datatip:
set(hDatatip,'UIContextMenu',get(cursorMode,'UIContextMenu'));
set(hDatatip,'HandleVisibility','off');
set(hDatatip,'Host',hTarget);
set(hDatatip,'ViewStyle','datatip');
 
% Set the data-tip orientation to top-right rather than auto
if 1
set(hDatatip,'OrientationMode','manual');
set(hDatatip,'Orientation','top-right');
end
% Update the datatip marker appearance
set(hDatatip, 'MarkerSize',5, 'MarkerFaceColor','none', ...
              'MarkerEdgeColor','k', 'Marker','o', 'HitTest','off');
 
% Move the datatip to the right-most data vertex point
%position = [xdata(end),ydata(end),1; xdata(end),ydata(end),-1];
update(hDatatip, position);